Code

git-stash: Make sure reflog is created for refs/stash
[git.git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[ | list | show | apply | clear]'
6 SUBDIRECTORY_OK=Yes
7 . git-sh-setup
8 require_work_tree
9 cd_to_toplevel
11 TMP="$GIT_DIR/.git-stash.$$"
12 trap 'rm -f "$TMP-*"' 0
14 ref_stash=refs/stash
16 no_changes () {
17         git diff-index --quiet --cached HEAD &&
18         git diff-files --quiet
19 }
21 clear_stash () {
22         if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
23         then
24                 git update-ref -d refs/stash $current
25         fi
26 }
28 save_stash () {
29         stash_msg="$1"
31         if no_changes
32         then
33                 echo >&2 'No local changes to save'
34                 exit 0
35         fi
36         test -f "$GIT_DIR/logs/$ref_stash" ||
37                 clear_stash || die "Cannot initialize stash"
39         # Make sure the reflog for stash is kept.
40         : >>"$GIT_DIR/logs/$ref_stash"
42         # state of the base commit
43         if b_commit=$(git rev-parse --verify HEAD)
44         then
45                 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
46         else
47                 die "You do not have the initial commit yet"
48         fi
50         if branch=$(git symbolic-ref -q HEAD)
51         then
52                 branch=${branch#refs/heads/}
53         else
54                 branch='(no branch)'
55         fi
56         msg=$(printf '%s: %s' "$branch" "$head")
58         # state of the index
59         i_tree=$(git write-tree) &&
60         i_commit=$(printf 'index on %s' "$msg" |
61                 git commit-tree $i_tree -p $b_commit) ||
62                 die "Cannot save the current index state"
64         # state of the working tree
65         w_tree=$( (
66                 rm -f "$TMP-index" &&
67                 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
68                 GIT_INDEX_FILE="$TMP-index" &&
69                 export GIT_INDEX_FILE &&
70                 git read-tree -m $i_tree &&
71                 git add -u &&
72                 git write-tree &&
73                 rm -f "$TMP-index"
74         ) ) ||
75                 die "Cannot save the current worktree state"
77         # create the stash
78         if test -z "$stash_msg"
79         then
80                 stash_msg=$(printf 'WIP on %s' "$msg")
81         else
82                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
83         fi
84         w_commit=$(printf '%s\n' "$stash_msg" |
85                 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
86                 die "Cannot record working tree state"
88         git update-ref -m "$stash_msg" $ref_stash $w_commit ||
89                 die "Cannot save the current status"
90         printf >&2 'Saved "%s"\n' "$stash_msg"
91 }
93 have_stash () {
94         git rev-parse --verify $ref_stash >/dev/null 2>&1
95 }
97 list_stash () {
98         have_stash || return 0
99         git log --pretty=oneline -g "$@" $ref_stash |
100         sed -n -e 's/^[.0-9a-f]* refs\///p'
103 show_stash () {
104         flags=$(git rev-parse --no-revs --flags "$@")
105         if test -z "$flags"
106         then
107                 flags=--stat
108         fi
109         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
111         w_commit=$(git rev-parse --verify "$s") &&
112         b_commit=$(git rev-parse --verify "$s^") &&
113         git diff $flags $b_commit $w_commit
116 apply_stash () {
117         git diff-files --quiet ||
118                 die 'Cannot restore on top of a dirty state'
120         unstash_index=
121         case "$1" in
122         --index)
123                 unstash_index=t
124                 shift
125         esac
127         # current index state
128         c_tree=$(git write-tree) ||
129                 die 'Cannot apply a stash in the middle of a merge'
131         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
132         w_tree=$(git rev-parse --verify "$s:") &&
133         b_tree=$(git rev-parse --verify "$s^:") ||
134                 die "$*: no valid stashed state found"
136         test -z "$unstash_index" || {
137                 git diff --binary $s^2^..$s^2 | git apply --cached
138                 test $? -ne 0 &&
139                         die 'Conflicts in index. Try without --index.'
140                 unstashed_index_tree=$(git-write-tree) ||
141                         die 'Could not save index tree'
142                 git reset
143         }
145         eval "
146                 GITHEAD_$w_tree='Stashed changes' &&
147                 GITHEAD_$c_tree='Updated upstream' &&
148                 GITHEAD_$b_tree='Version stash was based on' &&
149                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
150         "
152         if git-merge-recursive $b_tree -- $c_tree $w_tree
153         then
154                 # No conflict
155                 a="$TMP-added" &&
156                 git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
157                 git read-tree --reset $c_tree &&
158                 git update-index --add --stdin <"$a" ||
159                         die "Cannot unstage modified files"
160                 git-status
161                 rm -f "$a"
162                 test -z "$unstash_index" || git read-tree $unstashed_index_tree
163         else
164                 # Merge conflict; keep the exit status from merge-recursive
165                 status=$?
166                 test -z "$unstash_index" || echo 'Index was not unstashed.' >&2
167                 exit $status
168         fi
171 # Main command set
172 case "$1" in
173 list)
174         shift
175         if test $# = 0
176         then
177                 set x -n 10
178                 shift
179         fi
180         list_stash "$@"
181         ;;
182 show)
183         shift
184         show_stash "$@"
185         ;;
186 apply)
187         shift
188         apply_stash "$@"
189         ;;
190 clear)
191         clear_stash
192         ;;
193 help | usage)
194         usage
195         ;;
196 *)
197         if test $# -gt 0 && test "$1" = save
198         then
199                 shift
200         fi
201         save_stash "$*" && git-reset --hard
202         ;;
203 esac